<?php namespace Myriad\Squire;

use Carbon\Carbon;
use Illuminate\Support\Arr;

class FileResponse {

  /**
   * @var string
   */
  private $path;

  /**
   * @var int
   */
  private $contentLength;

  /**
   * @var string
   */
  private $contentType;

  /**
   * @var Carbon
   */
  private $lastModified;

  /**
   * FileResponse constructor.
   *
   * @param $data
   */
  public function __construct($data) {
    // unwrap response
    $data = array_get($data, 'data', $data);

    $this->path = Arr::get($data, 'path');
    $this->contentLength = intval(Arr::get($data, 'contentLength'));
    $this->contentType = Arr::get($data, 'contentType');
    $this->lastModified = Carbon::parse(Arr::get($data, 'lastModified', time()));
  }

  /**
   * @return string
   */
  public function getPath() {
    return $this->path;
  }

  /**
   * @return int
   */
  public function getContentLength() {
    return $this->contentLength;
  }

  /**
   * @return string
   */
  public function getContentType() {
    return $this->contentType;
  }

  /**
   * @return Carbon
   */
  public function getLastModified() {
    return $this->lastModified;
  }

}